import sys as _sys
from nose.tools import (
    eq_ as eq, assert_not_equal as not_eq,
    ok_ as ok, assert_false as fail_if,
    raises, assert_raises
)


class expect_exc(object):
    def __init__(self, etype):
        self.etype = etype

    def __enter__(self):
        pass

    def __exit__(self, etype, exc, tb):
        if not etype:
            raise AssertionError("Expected %s, raised nothing" % self.etype.__name__)
        elif not isinstance(exc, self.etype):
            raise AssertionError("Expected %s, raised %r" % (self.etype.__name__, exc))
        else:
            _sys.exc_clear()
            return True
